#!/usr/bin/perl

##################################################
##    go.cgi (C)2006 David Zohar                ##
##################################################
use CGI::Carp 'fatalsToBrowser';
use CGI;
$q = new CGI;

$config = 'config.cgi';

$time = time;
$referer = $ENV{'HTTP_REFERER'};
$url = $ENV{'QUERY_STRING'};
$addy = $ENV{'REMOTE_ADDR'};
$user = $ENV{'PATH_INFO'};
$user =~ s/\///;
($username,$adv) = split(/\_/, $user);
&loadsettings;
sub loadsettings {
open(SET, "$config") || &plainerror("Could not open settings file($!)!");
@settings = <SET>;
close(SET);
foreach $line (@settings) {
	chomp($line);
	($name,$value) = split(/\|/,$line);
	$conf{$name} = $value;
}}
($sec, $min, $hour, $day, $mon, $year, $dweek, $dyear, $daylight) = localtime($time);
$month = $mon + 1;
$year = $year + 1900;
$filename = "$username\_$month-$year";

my $Cookie = $q->cookie(-name=>"$conf{'cookie_name'}"); 

if (defined($referer) ) {}
else { $referer = Unknown; }

open (HITS, ">>$conf{'data'}/hits/$filename");
flock (HITS, 2); 
print HITS "$username|$time|$adv|$addy|$referer\n";
flock (HITS, 8); 
close (HITS);

open (HITS, ">>$conf{'data'}/ips.txt");
flock (HITS, 2); 
print HITS "$time|$username|$adv|$addy\n";
flock (HITS, 8); 
close (HITS);

open(DATA, "$conf{'data'}/track/$username");
flock (DATA, 2);
@data = <DATA>;
flock (DATA, 8);
close(DATA);
$found = 0;
foreach $line (@data) {
  chomp($line);
  ($num,$sale,$log_ad) = split(/\|/,$line);
  if ($log_ad eq $adv) {
    $found = 1;
    last;
  }
}
open(DATA, ">$conf{'data'}/track/$username");
flock (DATA, 2);
if ($found eq "1") {
  foreach $line (@data) {
    chomp($line);
    ($num,$sale,$log_ad) = split(/\|/,$line);
    if ($log_ad eq $adv) {
      $num++;   
      print DATA "$num|$sale|$log_ad\n";
    } else {
      print DATA "$line\n";
    }
  }
} else {
  foreach $line (@data) {
    print DATA "$line\n";
  }
  print DATA "1|0|$adv\n";
}
  close(DATA);

if(defined($url) ){
open(PAGE, "$conf{'data'}/pages.txt");
flock (PAGE, 2);
@data = <PAGE>;
flock (PAGE, 8);
close(PAGE);
$found=0;
foreach $line (@data) {
    chomp($line);
    ($page,$host) = split(/\|/,$line);
if($page eq $url){ $found=1; last; }
}
if($found eq "1"){
    $c = $q->cookie(-name=>$conf{'cookie_name'},
                    -expires=>'+1y', 
                    -value=>"$user"
                    ); 
    print $q->header(-cookie=>$c, -Location=>"$host");
    $q->end_html;
exit;                 
}
else {
$c = $q->cookie(-name=>$conf{'cookie_name'},
                    -expires=>'+1y', 
                    -value=>"$user"
                    ); 
    print $q->header(-cookie=>$c, -Location=>"$conf{'default'}");
    $q->end_html;
exit;
}
}
else {
$c = $q->cookie(-name=>$conf{'cookie_name'},
                    -expires=>'+1y', 
                    -value=>"$user"
                    ); 
    print $q->header(-cookie=>$c, -Location=>"$conf{'default'}");
    $q->end_html;
exit;
}